%Declaring required variables
l2 = 1; l3 = 158; l4 = 69;   %Link Lengths
l4x = -7; l4y = -120;       

step = 1;
i = 1;

%Matrix that stores theta, coordinate points
theta = zeros(360, 2);          
mechpts = zeros(360, 4, 2);          

%Initial guess and flag variable to check whether to exit the loop
t3 = 250;
t4 = 205;
flag = 1;

while(i<=360)
    t2 = i;
    condn = true;
    iterate = 10;
    while(condn && iterate)
        iterate = iterate - 1;
        
        %Loop Closure Equations, Jacobian, Newton Raphston Method, ...
        j = [-l3*sind(t3), -l4*sind(t4); l3*cosd(t3), l4*cosd(t4)];
        f = -[l2*cosd(t2) + l3*cosd(t3) + l4*cosd(t4) - l4x;...
            l2*sind(t2) + l3*sind(t3) + l4*sind(t4) - l4y];
        x = j\f;
        %Update the variables
        t3 = t3 + x(1,1)*180/pi;
        t4 = t4 + x(2,1)*180/pi;
        if(abs(x(1,1))<0.0001 && abs(x(2,1))<0.0001)
            condn = false;
        end
        if(iterate == 0)    %To check whether Newton Raphston method converges
            flag=0;
        end
    end
    if (flag==0)
        limits(1) = i-1;
        break;
    end
    theta(i, 1) = t3;   
    theta(i, 2) = t4;
    
    i = i + step;  
end

inlimits = true;
j = 1;     %Initial orientation

% Animating done by displaying various instant of the mechanism continously
while(inlimits)

    %Calculating the x, y  coordinates
    mechpts(j, 2, 1) = l2*cosd(j);
    mechpts(j, 2, 2) = l2*sind(j);
    mechpts(j, 3, 1) = mechpts(j, 2, 1) + l3*cosd(theta(j, 1));
    mechpts(j, 3, 2) = mechpts(j, 2, 2) + l3*sind(theta(j, 1));
    mechpts(j, 4, 1) = mechpts(j, 3, 1) + l4*cosd(theta(j, 2));
    mechpts(j, 4, 2) = mechpts(j, 3, 2) + l4*sind(theta(j, 2));
    
    %Ploting lines and circles to get a instantaneous picture of the
    %mechanism
%     hold off
%     plot([mechpts(j, 1, 1) mechpts(j, 2, 1)],...
%         [mechpts(j, 1, 2) mechpts(j, 2, 2)], 'LineWidth', 3, 'Color', 'b')
%     hold on
%     plot([mechpts(j, 2, 1) mechpts(j, 3, 1)],...
%         [mechpts(j, 2, 2) mechpts(j, 3, 2)], 'LineWidth', 3, 'Color', 'b')
%     hold on
%     plot([mechpts(j, 3, 1) mechpts(j, 4, 1)],...
%         [mechpts(j, 3, 2) mechpts(j, 4, 2)], 'LineWidth', 3, 'Color', 'b')
%     hold on
%     plot(mechpts(j, :,1), mechpts(j, :,2), 'r.', 'MarkerSize', 23)
%     hold on   

    pause(0.010);
    j = j + 1;
    if(j > 360)     %Final orientation
        inlimits = false;
    end
end

fig1 = figure;
plot(mechpts(:, 2, 1), mechpts(:, 2, 2));
title('Point 2');
saveas(fig1, 'Pt2.jpg');
close all;

fig2 = figure;
plot(mechpts(:, 3, 1), mechpts(:, 3, 2));
title('Point 3');
saveas(fig2, 'pt3.jpg');
close all;

fig3 = figure;
plot(1:360, (56.2+6.5) - mechpts(:, 3, 1));
title('Discharge opening in cm');
saveas(fig3, 'xdel.jpg');
close all;

fig5 = figure;
plot(1:360, (56.2+6.5) - mechpts(:, 2, 1));
title('Opening at top in cm');
saveas(fig5, 'xdel2.jpg');
close all;

fig4 = figure;
plot(1:360, abs(mechpts(:, 2, 2) - mechpts(:, 3, 2)));
title('Wall height used for crushing');
saveas(fig4, 'ydel.jpg');
close all;
